# spacestudio-satellite-demo-client
This API is a demo version of the SpaceStudio Satellite API. It is a simplified version of the SpaceStudio Satellite API, with a limited set of functionalities and a reduced set of endpoints. It is intended to be used for demonstration purposes only.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.18
- Package version: 1.0.18
- Generator version: 7.9.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import spacestudio_satellite_demo_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import spacestudio_satellite_demo_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import spacestudio_satellite_demo_client
from spacestudio_satellite_demo_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://demo.spacestudio-satellite.exotrail.space
# See configuration.py for a list of all supported configuration parameters.
configuration = spacestudio_satellite_demo_client.Configuration(
    host = "https://demo.spacestudio-satellite.exotrail.space"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: BearerAuth
configuration = spacestudio_satellite_demo_client.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with spacestudio_satellite_demo_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = spacestudio_satellite_demo_client.ComputationsApi(api_client)

    try:
        # CancelAllComputations
        api_instance.cancel_computations()
    except ApiException as e:
        print("Exception when calling ComputationsApi->cancel_computations: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://demo.spacestudio-satellite.exotrail.space*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ComputationsApi* | [**cancel_computations**](docs/ComputationsApi.md#cancel_computations) | **POST** /guest/computations/cancel | CancelAllComputations
*ComputationsApi* | [**get_computations_count**](docs/ComputationsApi.md#get_computations_count) | **HEAD** /guest/computations | GetComputationsCount
*OrbitsApi* | [**delete_orbit**](docs/OrbitsApi.md#delete_orbit) | **DELETE** /guest/orbits/{id} | DeleteOrbit
*OrbitsApi* | [**delete_orbits**](docs/OrbitsApi.md#delete_orbits) | **DELETE** /guest/orbits | DeleteOrbits
*OrbitsApi* | [**get_orbits**](docs/OrbitsApi.md#get_orbits) | **GET** /guest/orbits | GetOrbits
*PlatformsApi* | [**delete_platform**](docs/PlatformsApi.md#delete_platform) | **DELETE** /guest/platforms/{id} | DeletePlatform
*PlatformsApi* | [**delete_platforms**](docs/PlatformsApi.md#delete_platforms) | **DELETE** /guest/platforms | DeletePlatforms
*PlatformsApi* | [**get_platforms**](docs/PlatformsApi.md#get_platforms) | **GET** /guest/platforms | GetPlatforms
*PropulsionSystemsApi* | [**delete_propulsion_system**](docs/PropulsionSystemsApi.md#delete_propulsion_system) | **DELETE** /guest/propulsionsystems/{id} | DeletePropulsionSystem
*PropulsionSystemsApi* | [**delete_propulsion_systems**](docs/PropulsionSystemsApi.md#delete_propulsion_systems) | **DELETE** /guest/propulsionsystems | DeletePropulsionSystems
*PropulsionSystemsApi* | [**get_propulsion_systems**](docs/PropulsionSystemsApi.md#get_propulsion_systems) | **GET** /guest/propulsionsystems | GetPropulsionSystems
*ScenariosApi* | [**create_scenario**](docs/ScenariosApi.md#create_scenario) | **POST** /guest/scenarios | CreateScenario
*ScenariosApi* | [**delete_scenario**](docs/ScenariosApi.md#delete_scenario) | **DELETE** /guest/scenarios/{id} | DeleteScenario
*ScenariosApi* | [**delete_scenarios**](docs/ScenariosApi.md#delete_scenarios) | **DELETE** /guest/scenarios | DeleteScenarios
*ScenariosApi* | [**duplicate_scenario**](docs/ScenariosApi.md#duplicate_scenario) | **POST** /guest/scenarios/{id}/copy | DuplicateScenario
*ScenariosApi* | [**get_scenario**](docs/ScenariosApi.md#get_scenario) | **GET** /guest/scenarios/{id} | GetScenario
*ScenariosApi* | [**get_scenario_examples**](docs/ScenariosApi.md#get_scenario_examples) | **GET** /guest/scenarios/examples | GetScenarioExamples
*ScenariosApi* | [**get_scenarios**](docs/ScenariosApi.md#get_scenarios) | **GET** /guest/scenarios | GetScenarios
*ScenariosApi* | [**import_scenario_example**](docs/ScenariosApi.md#import_scenario_example) | **POST** /guest/scenarios/importexample | ImportScenarioExample
*ScenariosApi* | [**patch_scenario**](docs/ScenariosApi.md#patch_scenario) | **PATCH** /guest/scenarios/{id} | PatchScenario
*SpacecraftGeometriesApi* | [**delete_spacecraft_geometries**](docs/SpacecraftGeometriesApi.md#delete_spacecraft_geometries) | **DELETE** /guest/geometries | DeleteSpacecraftGeometries
*SpacecraftGeometriesApi* | [**delete_spacecraft_geometry**](docs/SpacecraftGeometriesApi.md#delete_spacecraft_geometry) | **DELETE** /guest/geometries/{id} | DeleteSpacecraftGeometry
*SpacecraftGeometriesApi* | [**get_spacecraft_geometries**](docs/SpacecraftGeometriesApi.md#get_spacecraft_geometries) | **GET** /guest/geometries | GetSpacecraftGeometries
*StudiesApi* | [**create_computation**](docs/StudiesApi.md#create_computation) | **POST** /guest/studies/{id}/computation | CreateComputation
*StudiesApi* | [**create_study**](docs/StudiesApi.md#create_study) | **POST** /guest/studies | CreateStudy
*StudiesApi* | [**delete_study**](docs/StudiesApi.md#delete_study) | **DELETE** /guest/studies/{id} | DeleteStudy
*StudiesApi* | [**get_studies**](docs/StudiesApi.md#get_studies) | **GET** /guest/studies | GetStudies
*StudiesApi* | [**get_study**](docs/StudiesApi.md#get_study) | **GET** /guest/studies/{id} | GetStudy
*StudiesApi* | [**get_study_computation_case**](docs/StudiesApi.md#get_study_computation_case) | **GET** /guest/studies/{id}/case/{computationCaseIndex} | GetStudyComputationCase
*StudiesApi* | [**update_study**](docs/StudiesApi.md#update_study) | **PUT** /guest/studies/{id} | UpdateStudy
*SupportApi* | [**send_reported_issue**](docs/SupportApi.md#send_reported_issue) | **POST** /guest/support | sendReportedIssue


## Documentation For Models

 - [AdvancedOrbitParameters](docs/AdvancedOrbitParameters.md)
 - [AnalyticalStudyParameters](docs/AnalyticalStudyParameters.md)
 - [AtmosphericModel](docs/AtmosphericModel.md)
 - [BaselineConfiguration](docs/BaselineConfiguration.md)
 - [CircularAltitudeOrbitParameters](docs/CircularAltitudeOrbitParameters.md)
 - [CircularGroundTrackRepeatedOrbitParameters](docs/CircularGroundTrackRepeatedOrbitParameters.md)
 - [ComparisonItem](docs/ComparisonItem.md)
 - [Computation](docs/Computation.md)
 - [ComputationMode](docs/ComputationMode.md)
 - [ComputationOutputs](docs/ComputationOutputs.md)
 - [ComputationStatus](docs/ComputationStatus.md)
 - [ComputationType](docs/ComputationType.md)
 - [ContextOutputs](docs/ContextOutputs.md)
 - [Deorbitation](docs/Deorbitation.md)
 - [DisplayConfiguration](docs/DisplayConfiguration.md)
 - [DisplayConfigurationComparisonOverview](docs/DisplayConfigurationComparisonOverview.md)
 - [DragPerturbation](docs/DragPerturbation.md)
 - [DuplicateScenarioRequest](docs/DuplicateScenarioRequest.md)
 - [EarthPotentialConfiguration](docs/EarthPotentialConfiguration.md)
 - [EarthPotentialPerturbation](docs/EarthPotentialPerturbation.md)
 - [EllipticalGroundTrackRepeatedEccentricityOrbitParameters](docs/EllipticalGroundTrackRepeatedEccentricityOrbitParameters.md)
 - [EllipticalPerigeeAltApogeeAltOrbitParameters](docs/EllipticalPerigeeAltApogeeAltOrbitParameters.md)
 - [EllipticalPerigeeAltEccentricityOrbitParameters](docs/EllipticalPerigeeAltEccentricityOrbitParameters.md)
 - [EllipticalSmaEccentricityOrbitParameters](docs/EllipticalSmaEccentricityOrbitParameters.md)
 - [Example](docs/Example.md)
 - [HarrisPriesterAtmosphericModel](docs/HarrisPriesterAtmosphericModel.md)
 - [LeoStationKeeping](docs/LeoStationKeeping.md)
 - [Maneuver](docs/Maneuver.md)
 - [ManeuverTimelineSlot](docs/ManeuverTimelineSlot.md)
 - [ManeuveringStrategy](docs/ManeuveringStrategy.md)
 - [NRLMSISE00AtmosphericModel](docs/NRLMSISE00AtmosphericModel.md)
 - [NumericalEphemeris](docs/NumericalEphemeris.md)
 - [NumericalOutputsConfiguration](docs/NumericalOutputsConfiguration.md)
 - [NumericalStudyParameters](docs/NumericalStudyParameters.md)
 - [Orbit](docs/Orbit.md)
 - [OrbitParameters](docs/OrbitParameters.md)
 - [OrbitPhasing](docs/OrbitPhasing.md)
 - [OrbitPropagation](docs/OrbitPropagation.md)
 - [OrbitTimelineSlot](docs/OrbitTimelineSlot.md)
 - [OrbitalTransfer](docs/OrbitalTransfer.md)
 - [Payload](docs/Payload.md)
 - [Perturbation](docs/Perturbation.md)
 - [PerturbationType](docs/PerturbationType.md)
 - [Platform](docs/Platform.md)
 - [Plot](docs/Plot.md)
 - [PropulsionSystem](docs/PropulsionSystem.md)
 - [RaanPhasing](docs/RaanPhasing.md)
 - [RefreshMode](docs/RefreshMode.md)
 - [ReportedIssue](docs/ReportedIssue.md)
 - [Scenario](docs/Scenario.md)
 - [ScenarioBaseline](docs/ScenarioBaseline.md)
 - [SimulationConfiguration](docs/SimulationConfiguration.md)
 - [SingleSatelliteAnalyticalComputationOutputs](docs/SingleSatelliteAnalyticalComputationOutputs.md)
 - [SingleSatelliteNumericalComputationOutputs](docs/SingleSatelliteNumericalComputationOutputs.md)
 - [SolarRadiationPressurePerturbation](docs/SolarRadiationPressurePerturbation.md)
 - [SpacecraftGeometry](docs/SpacecraftGeometry.md)
 - [Study](docs/Study.md)
 - [StudyComputation](docs/StudyComputation.md)
 - [StudyInputs](docs/StudyInputs.md)
 - [StudyParameters](docs/StudyParameters.md)
 - [Tab](docs/Tab.md)
 - [ThirdBodyPerturbation](docs/ThirdBodyPerturbation.md)
 - [ThrustArcsPosition](docs/ThrustArcsPosition.md)
 - [TimelineSlot](docs/TimelineSlot.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="BearerAuth"></a>
### BearerAuth

- **Type**: Bearer authentication


## Author




